"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BufferType = void 0;

var _typeDetect = _interopRequireDefault(require("type-detect"));

var _internals = require("../internals");

var _type = require("./type");

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
class BufferType extends _type.Type {
  constructor(options) {
    super(_internals.internals.binary(), options);
  }

  handleError(type, {
    value
  }) {
    if (type === 'any.required' || type === 'binary.base') {
      return `expected value of type [Buffer] but got [${(0, _typeDetect.default)(value)}]`;
    }
  }

}

exports.BufferType = BufferType;