"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.nonEmptyEndpointNestedEntriesArray = exports.endpointNestedEntriesArray = void 0;

var t = _interopRequireWildcard(require("io-ts"));

var _entry_match = require("../entry_match");

var _entry_match_any = require("../entry_match_any");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
const endpointNestedEntriesArray = t.array(t.union([_entry_match.endpointEntryMatch, _entry_match_any.endpointEntryMatchAny]));
exports.endpointNestedEntriesArray = endpointNestedEntriesArray;

/**
 * Types the nonEmptyNestedEntriesArray as:
 *   - An array of entries of length 1 or greater
 *
 */
const nonEmptyEndpointNestedEntriesArray = new t.Type('NonEmptyEndpointNestedEntriesArray', u => endpointNestedEntriesArray.is(u) && u.length > 0, (input, context) => {
  if (Array.isArray(input) && input.length === 0) {
    return t.failure(input, context);
  } else {
    return endpointNestedEntriesArray.validate(input, context);
  }
}, t.identity);
exports.nonEmptyEndpointNestedEntriesArray = nonEmptyEndpointNestedEntriesArray;