/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
import * as t from 'io-ts';
import { list } from '../lists';
/**
 * Types the DefaultListArray as:
 *   - If null or undefined, then a default array of type list will be set
 */

export var DefaultListArray = new t.Type('DefaultListArray', t.array(list).is, function (input, context) {
  return input == null ? t.success([]) : t.array(list).validate(input, context);
}, t.identity);